package hk.topicon.demo.ignitionevent;

import android.app.Activity;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

import android.os.PowerManager;

import android.os.Bundle;

import android.widget.TextView;

import android.view.KeyEvent;

import android.util.Log;

public class DemoIgnitionEventActivity extends Activity
{
    private static final String TAG = "DemoIgnitionEventActivity";

    private static final String ACTION_IGNITION = "hk.topicon.intent.action.IGNITION";

    private TextView mMsgBcast;

    private IntentFilter mIntentFilter;

    private PowerManager.WakeLock mWakeLock;

    private BroadcastReceiver mIgnitionReceiver = new BroadcastReceiver() {
	    @Override
	    public void onReceive(Context context, Intent intent) {
		String action  = intent.getAction();
		if(!action.equals(ACTION_IGNITION))
		    return;

		boolean state = intent.getBooleanExtra("state", false);
		final int MSG_ID = (state) ? R.string.ignition_event_on :
		    R.string.ignition_event_off;

		mMsgBcast.setText(MSG_ID);
		Log.d(TAG, "ignition event : " + getResources().getText(MSG_ID));

		/* swtich the display on, this wake lock timeouts immediately */
		mWakeLock.acquire(1);
	    }
	};

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

	mMsgBcast = (TextView) findViewById(R.id.msg_bcast);

	mIntentFilter = new IntentFilter();
        mIntentFilter.addAction(ACTION_IGNITION);

	PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        mWakeLock = pm.newWakeLock(PowerManager.SCREEN_BRIGHT_WAKE_LOCK |
				   PowerManager.ACQUIRE_CAUSES_WAKEUP, TAG);

        registerReceiver(mIgnitionReceiver, mIntentFilter);
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    @Override
    public void onPause() {
        super.onPause();
    }

        @Override
    public void onDestroy() {
        super.onDestroy();
	unregisterReceiver(mIgnitionReceiver);
    }

}
